import { useMemo } from 'react';
import useResponsive from './useResponsive';

var useIsMobile = function useIsMobile() {
  var _useResponsive = useResponsive(),
      isCalculated = _useResponsive.isCalculated,
      lessThan = _useResponsive.lessThan,
      mobileBreakpoint = _useResponsive.mobileBreakpoint;

  var isMobile = lessThan[mobileBreakpoint];
  return useMemo(function () {
    return {
      isMobile: isMobile,
      isCalculated: isCalculated
    };
  }, [isMobile, isCalculated]);
};

export default useIsMobile;